<!doctype html>
<html <?php language_attributes(); ?>>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?php wp_head(); ?>
    <style>
      span[class^="dot-"]{
        opacity: 0;
      }
      .dot-one{
        animation: dot-one 2s infinite linear
      }
      .dot-two{
        animation: dot-two 2s infinite linear
      }
      .dot-three{
        animation: dot-three 2s infinite linear
      }
      @keyframes dot-one{
        0%{
          opacity: 0;
        }
        15%{
          opacity: 0;
        }
        25%{
          opacity: 1;
        }
        100%{
          opacity: 1;
        }
      }

      @keyframes dot-two{
        0%{
          opacity: 0;
        }
        25%{
          opacity: 0;
        }
        50%{
          opacity: 1;
        }
        100%{
          opacity: 1;
        }
      }

      @keyframes dot-three{
        0%{
          opacity: 0;
        }
        50%{
          opacity: 0;
        }
        75%{
          opacity: 1;
        }
        100%{
          opacity: 1;
        }
      }
    </style>
  </head>

  <body <?php body_class(); ?> style="background-color: #010d19;">
    <?php wp_body_open(); ?>
    <?php do_action('get_header'); ?>

    <div id="app" class="banner bg-jlg-dark-blue text-jlg-white font-authentic flex w-full flex-col justify-center items-center" style="opacity: 0; transition: opacity 0.2s ease-out;">
      <?php echo view(app('sage.view'), app('sage.data'))->render(); ?>
    </div>

    <div id="loading" style="
        width: 100vw;
        height: 100vh;
        background-color: #010d19;
        z-index: 9999;
        position: fixed;
        top: 0;
        left: 0;
        display: flex;
        justify-content: center;
        align-items: center;
        font-family: sans-serif;
        color: white;
        opacity: 1;
        transition: opacity 0.2s ease-out;
    ">
      <p>
        Chargement
        <span class="dot-one">.</span>
        <span class="dot-two">.</span>
        <span class="dot-three">.</span>
      </p>
    </div>


    <script>
      document.addEventListener('DOMContentLoaded', function () {
      }, false);
    </script>

    <?php do_action('get_footer'); ?>
    <?php wp_footer(); ?>
  </body>
</html>
